package main

import (
	"bytes"
	"encoding/json"
	"log"

	"github.com/elastic/go-elasticsearch/v8/typedapi/core/search"
)

func parse_and_reverse(requestString string) {
	log.Printf("Request incoming: %s\n", requestString)
	req, err := search.NewRequest().FromJSON(requestString)
	if err != nil {
		log.Printf("Error %s", err)
	}

	buf := new(bytes.Buffer)
	enc := json.NewEncoder(buf)
	enc.Encode(req)
	log.Printf("Request outgoing: %s\n", buf.String())
	if err != nil {
		log.Printf("failed to create request 2: " + err.Error())
	}
}

func main() {
	log.Printf("Start")

	parse_and_reverse(`{
		"query": {
		  "bool": {
		    "filter": [
		      { "terms": { "Fields.lcf": ["bifd","gte"] } },
		      { "term": { "Fields.country": "Canada"} }
		    ],
		    "must": {
		      "multi_match": {
			"query": "Litigation",
			"fields": [ "Text", "Title^3"]
		      }
		    }
		  }
		},
		"fields": [
		  "Fields.global_rollup_key",
		  "Fields.collection_code",
		  "Fields.global_title"
		]
	      }`)

	parse_and_reverse(`{
		"query": {
		  "bool": {
		    "filter": [
		      { "terms": { "TermsQuery": {"Fields.lcf": ["bifd","gte"] } } },
		      { "term": { "Fields.country": "Canada"} }
		    ],
		    "must": {
		      "multi_match": {
			"query": "Litigation",
			"fields": [ "Text", "Title^3"]
		      }
		    }
		  }
		},
		"fields": [
		  "Fields.global_rollup_key",
		  "Fields.collection_code",
		  "Fields.global_title"
		]
	      }`)
}
